/*
 * Copyright (c) 2011, Olivier MATZ <zer0@droids-corp.org>
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _PARSE_ATCMD_H_
#define _PARSE_ATCMD_H_

struct token_atcmd_data {
	struct xbee_dev **xbee_dev;
	unsigned atcmd_flags;
	unsigned atcmd_mask;
};

struct token_atcmd {
	struct token_hdr hdr;
	struct token_atcmd_data atcmd_data;
};
typedef struct token_atcmd parse_token_atcmd_t;

struct token_atcmd_pgm {
	struct token_hdr hdr;
	struct token_atcmd_data atcmd_data;
} PROGMEM;
typedef struct token_atcmd_pgm parse_pgm_token_atcmd_t;

extern struct token_ops token_atcmd_ops;

#define TOKEN_ATCMD_INITIALIZER(structure, field, dev, flags, mask)	\
{									\
	.hdr = {							\
		.ops = &token_atcmd_ops,				\
		.offset = offsetof(structure, field),			\
	},								\
	.atcmd_data = {							\
		.xbee_dev = dev,					\
		.atcmd_flags = flags,					\
		.atcmd_mask = mask,					\
	},								\
}

#endif /* _PARSE_ATCMD_H_ */
